package com.nickmacholl.minecraft.DropStop.events;

import java.util.List;

import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockBreakEvent;

import com.nickmacholl.minecraft.DropStop.DropStop;

public class BlockBreakListener implements Listener{
	
	public final DropStop plugin;
	
	public BlockBreakListener(DropStop plugin){
		this.plugin = plugin;
	}
	
	@EventHandler
	public void blockBreak(BlockBreakEvent event){
		World world = event.getBlock().getWorld();
		Player p = event.getPlayer();
		
		//Just skip all this is the player is immune to the plugin.
		if(!p.hasPermission("blockdrop.immune")){
			
			//Is the world set in the config? If so, work the magic.
			if(plugin.getConfig().isSet(world.getName())){
				
				//Are there any material exceptions to worry about?
				List<String> exceptions = plugin.getConfig().getStringList(world.getName() + ".exceptions");
				Material mat = event.getBlock().getType();
				
				if(!exceptions.contains(mat.toString())){
					
					//Cancel the block break to prevent items from spawning.
					event.setCancelled(true);
					
					//Should we drop some experience?
					if(plugin.getConfig().getBoolean(world + ".dropXP")){
						int exp = event.getExpToDrop();
						while(exp>0){
							world.spawnEntity(event.getBlock().getLocation(), EntityType.EXPERIENCE_ORB);
							exp--;
						}
					}
					
					//Set the block to air to fake like it did break.
					event.getBlock().setType(Material.AIR);
				}
			}
		}
	}
}
